; copied  01/21/92
; updated 01/22/92
;   revised 02/15/93
;	KILLTIME to save ES
;   revised 04/04/93
;       add RAZZBERRY
;   revised 05/10/93
;       delay setting Fudge until floppy motor spin stopped, add better
;	port information.
;   revised 06/28/93
;	to Lock out Windows during delay loop

;=====================================================================
;   Delay (now KillTime) & Fudge were
;   Written by Christy Gemmell
;              Singular Software
;              22 Peake Road, Northfields
;              Leicester LE4 7DN, England
;   For QBNews and released into the Public Domain.
;Revisions 
;   Copyright (C) Copr. 1990, 1991, 1992, 1993 by Sidney J. Kelly
;                   All Rights Reserved.
;           Sidney J. Kelly
;           150 Woodhaven Drive
;           Pittsburgh, PA 15228
;           home phone 412-561-0950 (7pm to 9:30pm EST)
;=====================================================================

;;;RM120

DOSSEG
.MODEL MEDIUM, BASIC
.DATA
	; this works inside QB as well as in run time version
	EXTRN	__osversion:WORD ; this holds minor version in highbyte,
				 ; major version in lowbyte
.CODE

EVEN  	; holds fudge factor and counting register
Factor  LABEL   WORD
	 DW      0
	 DW      0
Counter LABEL   WORD
	 DW      ?
	 DW      ?

;
; DECLARE SUB KILLTIME (BYVAL DTIME%)
;       Millisecond delay loop.
;  Trashes:
;                AX, BX, CX, DX
;  Saves:
; 		 SI, DI, BP, CLD, DS, ES, SS
;

EVEN
GetFudge:
	Call    Near Ptr Fudge          ; Otherwise get it
	Jmp     Short Start_Section     ; return w/ Fudge in DX:AX
EVEN
KILLTIME PROC FAR BASIC, DTIME:WORD
	Assume  DS:@data, ES:NOTHING
	Mov     CX,DTIME                ; Get delay required (Note BYVAL)
	Jcxz    Quit                    ; Quit if zero
	Mov     AX,CS                   ; Make DS = CSEG
	Mov     DS,AX
	Assume  DS:@code		; tell MASM of change
	Mov     AX,Factor               ; Load fudge factor
	Mov     DX,Factor[2]            ;    into DX:AX
	Or      AX,AX                   ; Has fudge been set?
	Jz      GetFudge                ; no, so get it
Start_Section:
	Mov     BX,43                   ; Divide DX:AX by 43 to get
	Div     BX                      ;   loop counter value (quotient)
	; 43 is 2 * 18.2 plus some plug value so we get close to 1 second
	; if DTIME% = 1000d
EVEN					; speed up 8086/80286/80386 access
Outer_Loop:
	Mov     Counter,AX              ; Set up for 1 msec delay
	Mov     Counter[2],0            ; High word is not used
					; except to waste time
EVEN					; speed up 8086/80286/80386 access
Inner_Loop:
	Sub     Counter,1               ; Decrement count
	Sbb     Counter[2],0            ; (Decrement Counter[2] upon carry)
	Jns     Inner_Loop              ;    for 1 millisecond
	Loop    Outer_Loop              ;      for n milliseconds
Quit:
	Mov	AX,SS			; reset DS to DGROUP
	Mov	DS,AX
	Assume	DS:@data		; tell MASM of change
	Ret
KILLTIME ENDP

;
;      Calculate KILLTIME fudge factor for host system.
;      Routine name is made private through use of Label Near
;
;  Returns:
;              Fudge Factor set in Factor and in DX:AX
;  Trashes:
;              AX
;  Preserves:
;              All other registers
;

EVEN					; speed up 8086/80286/80386 access
Fudge Label Near			; this makes name private
	Assume	SS:@data
	Push	ES			; save ES
	Cmp	Byte Ptr SS:[__osversion],2	; make sure DOS version 3.xx+
	Je	@f			; (skip Windows stuff if DOS ver 2.xx)
	Mov	AX,1681h		; prevent Windows interruption
	Int	2Fh
@@:
	Xor     AX,AX                   ; Zero AX
	Mov     Factor,AX               ; Initialize
	Mov     Factor[2],AX            ;    local data
	Mov     ES,AX                   ; Point ES to page zero
	Assume  ES:NOTHING		; tell MASM
	Cli				; prevent interrupts
	Mov     BX,Word Ptr ES:[046Ch]  ; get current timer count
	Mov     DX,Word Ptr ES:[046Eh]  ; get high word
	Sti				; allow interrupts again
	Add	BX,91			; add 5 seconds
	Adc	DX,0			; if carry add 1 to DX
	Cmp	DX,17h			; is that time > midnight?
	Jb	Wait_On_Floppy		; no, so skip ahead
	Cmp	BX,0FE80h		; is that time > midnight?
	Jb	Wait_On_Floppy		; no, so skip ahead
	Mov	BX,5			; make it 5 seconds after midnight
EVEN
Wait_On_Floppy:
	; Because some systems reduce clock speed if the floppy is active
	; (so old style games and copy protection can work), e.g.
	; COMPAQ 12MHZ 286, this routine waits until all floppy drives
	; have stopped spinning.  See, Rubenking, PC Techniques
	; V1,N3,P60 (Aug/Sept. 1990)
	Mov	AL,Byte Ptr ES:[043Fh]	; get bios floppy info byte
	And	AL,01111b		; clear high bits
	Jz	@f			; if AL = 0, then a floppy inactive
	Mov     AX,Word Ptr ES:[046Ch]  ; Get current timer count
	Cmp	AX,BX			; is current < final
	Jb	Wait_On_Floppy		; yes, re-loop
@@:
	; time-out exit if floppy never stops
	Mov     AL,Byte Ptr ES:[046Ch]  ; Get current timer count
Sync_Loop:
	Cmp     AL,Byte Ptr ES:[046Ch]  ; Has it changed?
	Je      Sync_Loop               ; No, wait till it does
	Mov     AL,Byte Ptr ES:[046Ch]  ; Yes, get new count
Calc_Loop:
	Add     Factor,1                ; Increment (counter in memory)
	Adc     Factor[2],0             ; fudge factor (adds carry to Factor[2]
	Cmp     AL,ES:[046Ch]           ; Has timer changed yet?
	Je      Calc_Loop               ; then, keep incrementing
	Cmp	Byte Ptr SS:[__osversion],2	; make sure DOS version 3.xx+
	Je	@f			; (skip Windows stuff if DOS ver 2.xx)
	Mov	AX,1682h		; else, allow Windows interruption
	Int	2Fh			; again
@@:
	Mov     AX,Factor               ; get fudge
	Mov     DX,Factor[2]            ;    factor and return
	Pop	ES			; restore ES
	Retn                            ; Return to caller (NOTE NEAR Return)

;------------------------------
; created 11/10/90 sound routines
; updated 01/21/92
;
;
;   Copyright (C) Copr. 1990, 1991 by Sidney J. Kelly
;                   All Rights Reserved.
;           Sidney J. Kelly
;           150 Woodhaven Drive
;           Pittsburgh, PA 15228
;           home phone 412-561-0950 (7pm to 9:30pm EST)
;

;=======================================================================
; Much smaller sound program
; DECLARE SUB NUSOUND (BYVAL Freq%, BYVAL Duration%)
; CALL NUSOUND(Freq%, Duration%)
; Input:
; 	Freq% = Frequency
; 	Duration% = Number of miliseconds
;=======================================================================

EVEN					; speed up 8086/80286/80386 access
NUSOUND PROC FAR BASIC FREQ:PTR WORD, DURATION:PTR
	Mov     CX,DURATION		; get DURATION (Note BYVAL)
	JCXZ    FINIS			; if DURATION is 0 then quit
	Mov     AL,0B6h			; initialize Timer Channel 2
	; Initialize timer Channel 2, send LSB followed by MSB
	; Mode 3, square wave, binary output
	Out     43h,AL			; send to timer port
	; Adjust divisor for Channel 2 of Timer
	Mov     DX,12h			; load DX:AX with 1,190,000
	Mov     AX,2870h		; to convert frequency to 1/F
	Mov     BX,FREQ			; Get Freq  (Note BYVAL)
	CMP     BX,37
	JB      FINIS			; if less than 37 hertz, quit
	Div     BX			; now do calculation
	; Channel 2 I/O port is 42h
	CLI				; prevent interrupts
	Out     42h,AL			; send interval info to clock
	Mov     AL,AH			; send 16 bit word as 2 bytes
	JMP     $+2			; delay for AT or above
	Out     42h,AL
	JMP     $+2			; delay for AT or above
	; the following makes sure that speaker is connected to the timer.
	; It is not always necessary to do this.  QBASIC's sound routine
	; only does it once in a program.  We do here to be sure
	IN      AL,61h			; read timer port B
	OR      AL,3h			; set bits to turn on B
	; turn on speaker and give control to Timer Channel 2
	; but don't change other bits
	JMP     $+2			; delay for AT or above
	Out     61h,AL			; turn on speaker
	STI				; allow interrupts again
	;----------delay section----------------------
	Push	CX			; push the delay
	Push	CS			; do fast FAR call in current segment
	Call	Near Ptr KILLTIME	; call the KILLTIME routine
	;-----------end of delay-------------------------
	CLI				; prevent interrupts
	IN      AL,61h			; read timer port B
	And     AL,0FCh			; set bits to turn off speaker
	; but don't change other bits
	JMP     $+2			; delay for AT or above
	Out     61H,AL			; turn it off
	STI				; allow interrupts again
FINIS:
	Ret
NUSOUND ENDP

;constant for adjusting sound of BEEPER routines
DelayTime       EQU     48

;======================================================================
; DECLARE SUB BEEPER10
;       makes a short 750 Hz tone
;
;    This routine makes a beep tone in a speed independent fashion
;======================================================================

EVEN				; speed up 8086/80286/80386 access
BEEPER10 PROC FAR
	Mov	AX,750		; push desire frequency
	Push	AX
	Mov	AX,DelayTime	; push desired delay time
	Push	AX
	Push	CS		; fast far call w/in current segment
	Call	Near Ptr NUSOUND ; make the sound
	Ret
BEEPER10 ENDP

;======================================================================
; DECLARE SUB BEEPER20
;       makes a short 950 Hz tone
;
;    This routine makes a beep tone in a speed independent fashion
;======================================================================

EVEN				; speed up 8086/80286/80386 access
BEEPER20 PROC FAR
	Mov	AX,950		; push desire frequency
	Push	AX
	Mov	AX,DelayTime	; push desired delay time
	Push	AX
	Push	CS		; fast far call w/in current segment
	Call	Near Ptr NUSOUND ; make the sound
	Ret
BEEPER20 ENDP

;======================================================================
; DECLARE SUB RAZZBERRY
;       makes a long error tone
;    This routine makes a beep tone in a speed independent fashion
;======================================================================

EVEN
RAZZBERRY PROC FAR
	Mov     AX,80           ; push desire frequency
	Push    AX
	Mov     AX,500          ; push desired delay time
	Push    AX
	Push    CS               ; fast far call w/in current segment
	Call    Near Ptr NUSOUND ; make the sound
	Ret
RAZZBERRY ENDP
END

; These routines require BX to be preserved
; Older versions
EVEN
BEEPER10 PROC FAR
	; the following makes sure that speaker is connected to the timer.
	; It is not always necessary to do this.  QBASIC's sound routine
	; only does it once in a program.  We do here to be sure
	Mov     AL,0B6h         ; magic number 10110110b
	; select square wave sound  & initialize timer channel 2
	Out     43h,AL
	Mov     AX,0636h        ; send frequency, about 750 Hz
	Jmp     $+2             ; delay for AT's
	Out     42h,AL          ; send LSB of frequency
	Mov     AL,AH           ; get MSB into AL
	Jmp     $+2             ; delay for AT's
	Out     42h,AL          ; send MSB of frequency
	In      AL,61h          ; read port 61h
	Mov     BH,AL           ; store result in BH
				; must save BH!
	OR      AL,03           ; set the turn speak on bit
	Jmp     $+2             ; delay for AT's
	Out     61h,AL          ; send value to port
	Mov     AX,DelayTime    ; delay time
	Push	AX		; put delay on stack
	Push	CS		; fast call a FAR routine w/in same segment
	Call	Near Ptr KILLTIME
	Mov     AL,BH           ; get back old port value from BH
	Out     61h,AL          ; send it back to speaker port
        Ret
BEEPER10 ENDP


EVEN
BEEPER20 PROC FAR
	Mov     AL,0B6h         ; magic number 10110110b
	; select square wave sound  & initialize timer channel 2
	Out     43h,AL
	Mov     AX,04E7h        ; send frequency, about 950 Hz
	Jmp     $+2             ; delay for AT's
	Out     42h,AL          ; send LSB of frequency
	Mov     AL,AH           ; get MSB into AL
	Jmp     $+2             ; delay for AT's
	Out     42h,AL          ; send MSB of frequency
	In      AL,61h          ; read port 61h
	Mov     BH,AL           ; store result in BH
				; must SAVE BH!
	OR      AL,03           ; set the turn speak on bit
	Jmp     $+2             ; delay for AT's
	Out     61h,AL          ; send value to port
	Mov     AX,DelayTime    ; delay time
	Push	AX		; put delay on stack
	Push	CS		; fast call a FAR routine w/in same segment
	Call	Near Ptr KILLTIME
	Mov     AL,BH           ; get back old port value from BH
	Out     61h,AL          ; send it back to speaker port
	Ret
BEEPER20 ENDP

