; created 02/19/92
; updated 12/21/92

;=====================================================================
;   Copyright (C) Copr. 1992, 1993 by Sidney J. Kelly
;                   All Rights Reserved.
;           Sidney J. Kelly
;           150 Woodhaven Drive
;           Pittsburgh, PA 15228
;           home phone 412-561-0950 (7pm to 9:30pm EST)
;=====================================================================

DOSSEG
.MODEL MEDIUM, BASIC

EXTRN M$PRINT:FAR    ;fast string print routine w/ color choice
EXTRN M$PRT:FAR      ;fast string print program using existing colors
EXTRN DATE2JUL:FAR   ;fast conversion of date to serial julian number
EXTRN WEEKDAYNUM:FAR ;determines day of week of JulianNum&
EXTRN MAKEBOXES:FAR  ;make an attractive box around calendar

.DATA
        EXTRN  B$TEMPDATA:WORD       ;inside FDATA
        EXTRN  B$STRINGLEN:WORD      ;inside FDATA
        EXTRN  B$STRINGOFF:WORD      ;inside FDATA
.CODE

EVEN
cYear           dw  0           ; store adjusted year
cRow            dw  0           ; store adjusted row
cCol            dw  0           ; store incoming column +1
StartDay        db  0           ; store starting week day
MaxDays         db  0           ; store maximum days in months
DaysLeft        db  0           ; scratch, loop counter then days left
                                ; in MONTH

;indexed table of number of days in a MONTH for non-leap year, 0 based
NonLeap	  db  31,28,31,30,31,30,31,31,30,31,30,31

Header    db 'Su Mo Tu We Th Fr Sa'
; This makes sure we get a fixed length of 15
;             123456789012345
MonthName db ' January       '
	  db ' February      '
	  db ' March         '
	  db ' April         '
	  db ' May           '
	  db ' June          '
	  db ' July          '
	  db ' August        '
	  db ' September     '
	  db ' October       '
	  db ' November      '
	  db ' December      '

; saves us from having to convert from binary to ASCII
Numbers   db ' 1  2  3  4  5  6  7  8  9 10 11 12 13 14 15 16 17 18 19'
	  db ' 20 21 22 23 24 25 26 27 28 29 30 31 '

Buffer    db    5 dup(32)       ; buffer to print year string to

; RM120
;=======================================================================
; DECLARE FUNCTION MAKECAL% (BYVAL ROW%, BYVAL COL%, BYVAL MONTH%,
;  / BYVAL YEAR%, BYVAL HEADERATTR%, BYVAL MAINATTR%)
; Input:
;       Row: upper left hand corner, assuming 10 x 24 box size
;       Col: upper left hand corner
;       Month : Month to start calendar with
;       Year: Year to start calendar with
;       Headerattr: Attribute for "Month Year" and Header
;       Mainattr: Attribute for entire window and border
; Purpose:
;	prints a fast pop-up calendar, mostly printed in existing colors
;       HEADERATTR% allows choice of header color
; Returns:
;	 0 if no error
;	-1 if input error
; Warning:
;       No range check performed on ROW, COL, MAINATTR or HEADERATTR
; Speed:
;       About 5.3 times faster than a user code program
;=======================================================================

EVEN
Error:
	Mov	AX,-1		; return error
	Jmp	Quit		; quit
EVEN
MAKECAL PROC FAR BASIC USES DI, ROW:WORD, COL:WORD, MONTH:WORD, \
YEAR:WORD, HEADERATTR:WORD, MAINATTR:WORD

;---------------
; Assume CLD
; AX,BX,CX,DX used as scratch
; DI only used once in ConvertAX to string routine
;  then used to hold NumUsed, a counter for number of bytes printed
; DS does nothing
; ES set to CSEG for fast copying
;---------------
	Mov	AX,YEAR		; get YEAR (Note BYVAL)
	Cmp	AX,99		; is year less than 100?
	Ja	@f		; no, don't add 1990
	Add	AX,1900		; else add 1900
@@:
	Cmp	AX,1600		; range check Year < 1600?
	Jb	Error		; if yes then error
	Cmp	AX,3999		; range check Year > 3999
	Ja	Error		; if yes then error
	Mov	CS:[cYear],AX	; save Year value in storage
	Mov	AX,MONTH	; get MONTH (Note BYVAL)
	Cmp	AX,12		; range check of MONTH
	Ja	Error		; if > 12 then error
	Or	AX,AX		; if 0 then error
	Jz	Error
	Dec	AX		; make it 0 biased
	Mov	DI,AX		; DI holds MONTH zero biased
				; hold it temporarily
; Makes a box of a specified dimension
; CALL MAKEBOXES (ULR%, ULC%, LRR%, LRC%, HASNO%, BORDER%, MAINATTR%)
	Mov     AX,ROW
	Push    AX              ; send ULR
	Mov     CX,COL
	Push    CX              ; send ULC
	Add     AX,9
	Push    AX              ; send LRR
	Add     CX,23
	Push    CX              ; send LRC
	Mov     AX,32
	Push    AX              ; select a blank background character
	Mov     AX,2
	Push    AX              ; select single border, #2
	Push    MAINATTR        ; send the main color
	Call    MAKEBOXES       ; call routine

; Print MONTH Name
	Mov	AX,CS
	Mov	ES,AX
	Assume  DS:NOTHING,ES:NOTHING	; ES = CS
; lie about DS so offset is calculated correctly relative to CSEG
	Mov	BX,DI		; restore Month, zero based
	Mov	CX,OFFSET MonthName
	Xor	DX,DX		; clear DX for multiplication
	Mov     AX,15           ; length of each month name
	Mul	BX		; index into array
	Add	CX,AX		; add offset of source string
; DECLARE SUB M$PRINT (ROW%, COL%, SEGM%, OFFS%, LENGTH%, HEADERATTR%)
	Mov	AX,ROW		; (note BYVAL)
	Inc	AX		; ROW = ROW + 1 
	Push	AX
	Mov	AX,COL		; (note BYVAL)
	Inc	AX
	Inc	AX
	Push	AX		; COL = COL + 2
	Push	CS		; send segment
	Push	CX		; send offset
	Mov     AX,15           ; send string length
	Push	AX
	Push    HEADERATTR            ; send HEADERATTR
	Call	M$PRINT		; call string print routine
; Print YEAR string
	Mov	DI,OFFSET Buffer
	Mov	AX,CS:[cYear]
	;ES:DI must point to output buffer
	Call Near Ptr ConvertAX ; add Year string to Buffer
; DECLARE SUB M$PRINT (ROW%, COL%, SEGM%, OFFS%, LENGTH%, HEADERATTR%)
	Mov	AX,ROW		; (note BYVAL)
	Inc	AX		; ROW = ROW + 1 
	Push	AX
	Mov	AX,COL		; (note BYVAL)
	Add     AX,17
	Push    AX              ; COL = COL + 17 (to account for Month)
	Push	CS		; send segment
	Mov	AX,OFFSET Buffer ; get offset of buffer
	Push	AX		; send offset
	Mov     AX,5            ; send length
	Push	AX
	Push    HEADERATTR      ; send color for header
	Call	M$PRINT		; call string print routine
; Print Header
; DECLARE SUB M$PRINT (ROW%, COL%, SEGM%, OFFS%, LENGTH%, HEADERATTR%)
	Mov	AX,ROW		; note BYVAL
	Inc	AX
	Inc	AX		; Make it Row + 2
	Push	AX		; send it
	Mov	AX,COL		; note BYVAL
	Inc	AX
	Inc	AX		; Make it Col + 2
	Mov	Byte Ptr CS:[cCol],AL ;save col offset
	Push    AX              ; send it
	Push	CS		; send segment
	Mov	AX,Offset Header
	Push	AX		; send offset
	Mov	AX,20		; send length
	Push	AX
	Push    HEADERATTR      ; send attribute
	Call	M$PRINT		; call string print routine
; figure starting day w/in MONTH
	Push	MONTH		; push MONTH
	Mov	AX,1		; push 1 for the first day of Month
	Push	AX
	Push	CS:[cYear]	; push revised year
; CALL FUNCTION DATE2JUL(MONTH, Day, Year)
	Call    DATE2JUL	; DX:AX will contain JulNum&
	Push	DX		; push a long int value DX first
	Push	AX		; then AX
; CALL FUNCTION WEEKDAYNUM(JulNum&)
	Call    WEEKDAYNUM	; returns weekday num in AX
	Mov     CS:[StartDay],AL ; save it
; determine length of first string to print for 1st week of MONTH
	Mov	BL,7
	Sub	BL,AL		; get (7-StartDay) in BL
	Mov	AL,BL		; store in AL
	Shl	AL,1		; multiply AL by 2
	Add	AL,BL		; add BL so AL = (7-StartDay) * 3
	Xor     AH,AH           ; clear garbage from AH
	Mov	DI,AX		; save number of bytes printed in DI
	Mov     CX,AX           ; save number of bytes in CX
	Sub     CX,2            ; remove trailing byte at end of string
; DECLARE SUB M$PRT (ROW%, COL%, SEGM%, OFFS%, LENGTH%)
	Mov	AX,ROW		; (Note BYVAL)
	Add	AX,3		; send row to print
	Push	AX		; send ROW + 3
	Mov	Byte Ptr CS:[cRow],AL  ; save ROW
; determine maximum number of days in MONTH
	Mov	BX,MONTH	; get MONTH (Note BYVAL)
	Dec	BX		; make it zero based
	Mov	AL,NonLeap[BX]	; get number of days in MONTH
	Cmp	BX,1		; is MONTH February? (recall 0 bias)
	Jne	SaveIt		; no, so skip ahead
; Must preserve AX
	Call Near Ptr IS_LEAP?	; determine if a Feb. in leap year
	Jnc	SaveIt		; if no carry not a leap year
	Inc	AL		; record that Feb in leap has 29 days
SaveIt:
	Mov	CS:[MaxDays],AL ; save the maximum number of days
;Figure out where to print first week
	Mov	AL,CS:[StartDay]
	Mov	BL,AL		; store a copy of StartDay in BL
	Shl	AL,1		; multiply AL by 2
	Add	AL,BL		; make AL = (AL * 2) + BL or AL = AL * 3
	Add	AL,3		; AL = (StartDay * 3) + 3
	Mov	BX,COL		; (Note BYVAL)
	Add	BL,AL		; push COL + 3 + (StartDay * 3)
	Push	BX		; send COL
	Push	CS		; send segment
	Mov	AX,OFFSET Numbers
	Inc	AX		; send first week (skipping leading " ")
	Push	AX		; send offset
	Push    CX              ; send length of string
	Call    M$PRT		; call print routine
	;get ready to print middle three weeks
	; set up counter for MainLoop to count through 3 loops
	Mov	Byte Ptr CS:[DaysLeft],3  ;DaysLeft is a counter
MainLoop:
	Inc	CS:[cRow]	; update row
	Mov	BX,OFFSET Numbers	; put source offset of Numbers in BX
	Mov	AX,DI		; see where to begin copying from Numbers
	Add     BX,AX           ; add offset of beginning of week
; DECLARE SUB M$PRT (ROW%, COL%, SEGM%, OFFS%, LENGTH%)
	Push	CS:[cRow]	; push current Row
	Push	CS:[cCol]	; push current Col
	Push	CS		; send segment
	Push	BX		; send offset
	Mov     AX,20           ; send 20 bytes (ignore trailing " ")
	Push	AX		; send number of bytes to print
	Call    M$PRT		; call print routine
	Add	DI,21		; update counter for bytes printed
	Dec 	CS:[DaysLeft]	; dec counter
	Jz	End_Loop	; if hits 0, then quit loop
	Jmp	MainLoop	; else, restart loop
End_Loop:
	; see if last or next to last week
	Mov	BL,CS:[StartDay] ; get starting day of week
	Mov	AL,7
	Sub	AL,BL  		; calc 7 - StartDay
	Add	AL,21		; calc 21 + (7 - StartDay)
	Mov	BL,CS:[MaxDays]	; put MaxDays in BL
	Sub	BL,AL		; MaxDays - (21 + (7 - StartDay))
	Mov	CS:[DaysLeft],BL     ; store value
	Or      BL,BL           ; any days left? (is it special February?)
	Jz      Finis           ; e.g. 28 day month that began on Sunday?
	Cmp     BL,7            ; else, are there < 7 days left?
	Jb      Last_Row        ; if less 7 then jump to last week
; print next to last week
	Inc	CS:[cRow]	; update row
	Mov	BX,OFFSET Numbers ; put source offset of Numbers in BX
	Mov	AX,DI		; see where to begin copying from Numbers
	Add     BX,AX           ; add offset of beginning of week
; DECLARE SUB M$PRT (ROW%, COL%, SEGM%, OFFS%, LENGTH%)
	Push	CS:[cRow]	; push current Row
	Push	CS:[cCol]	; push current Col
	Push	CS		; send segment
	Push	BX		; send offset
	Mov     AX,20           ; send 19 bytes (ignore trailing " ")
	Push	AX		; send number of bytes to print
	Call    M$PRT		; call print routine
	Add	DI,21		; update counter for bytes printed
	Mov     BL,CS:[DaysLeft] ; note that a week has elapsed
	Sub     BL,7            ; did we print last day of month?
	Jz	Finis		; if that is it, then quit
Last_Row:
	;BL holds DaysLeft from previous week or test before jump
	Mov     AL,BL           ; store a copy of BL in AL
	Shl	AL,1		; multiply AL by 2
	Add	AL,BL		; add BL, make AL = AL * 3
	Xor	AH,AH		; clear garbage from AH
	Mov	CX,AX		; save for length of copy string
	Dec	CX		; eliminate any trailing space
	Inc	CS:[cRow]	; update row
; DECLARE SUB M$PRT (ROW%, COL%, SEGM%, OFFS%, LENGTH%)
	Push	CS:[cRow]	; push current Row
	Push	CS:[cCol]	; push current Col
	Push	CS		; send segment
	Mov	BX,OFFSET Numbers
	Mov	AX,DI		; get back how many already printed
	Add	BX,AX		; add already printed to offset
	Push    BX              ; send offset
	Push	CX		; send length
	Call    M$PRT		; call print routine
Finis:
	Xor	AX,AX		; return no error
Quit:
	Assume	DS:@data
	Ret
MAKECAL ENDP

;-----------------
; Input:
;	AX containing # < 9,999, 
;	ES:DI = current offset of buffer
;	CLD
;  Output:
;	left justifies string in buffer w/ leading '00'
;  Destroys:
;	AX,CX,DX
;-----------------
EVEN
ConvertAX Label Near            ; make name privates
	Xor     DX,DX           ; zero DX register
	Mov     CX,100          ; Divide AX by 100, yields
	Div     CX              ;   AX=quotient, DX=remainder
	AAM                     ; Make AL digits unpacked BCD
	XCHG    AL,AH           ; put digits in correct order
	Or      AX,'00'         ; Convert to ASCII
	Stosw                   ; store AX at ES:DI, update DI
	Mov     AX,DX           ; Do same thing for DX
	AAM                     ; MSB in AH, LSB in AL
	XCHG    AL,AH           ; put digits in correct order
	Or      AX,'00'         ; Return DX:AX = ASCII number
	Stosw                   ; store AX at ES:DI, update DI
	Retn

;--------------------------------------------
; Input:
;       Year in cYear
; Output:
;       if a leap year, CARRY set
;       if it is not a leap year, CARRY clear
; Preserves:
;       AX only
; Destroys:
;       BX, DX
;--------------------------------------------

EVEN
IS_LEAP? Label NEAR		; use a label to keep name private
	Assume ES:NOTHING
	Push	AX
	Mov     AX,CS:[cYear]
	Sub	AX,1200		; determine if year number is evenly
	Mov	BX,400		; divisible by 400
	Xor	DX,DX		; clear high word for testing below
	Div	BX
	Or	DX,DX		; is remainder zero?
	Jz	yes_leap	; yes, it's a leap year
 	Mov	AX,CS:[cYear]	; next check divisibility by 100
	Mov	BX,100
	Xor	DX,DX		; clear high word for testing below
	Div	BX
	Or	DX,DX		; is remainder zero?
	Jz	not_leap	; yes, divisible by 100 but not 400
	Mov	AX,CS:[cYear]	; finally, is it divisible by four?
	Mov	BX,4
	Xor	DX,DX		; clear high word for testing below
	Div	BX
	Or	DX,DX		; is remainder 0?
	Jz	yes_leap	; yes, it's a leap year
not_leap:
	Pop     AX              ; recover only preserved register
	Clc			; clear carry
	Retn
yes_leap:
	Pop     AX              ; recover only preserved register
	Stc			; set carry
	Retn			; note that it is a near routine
END

